/*------------------------------
 *
 * iQ[
 *
 * johnson wb_[
 * LAW\̊ǗS
 *
------------------------------*/

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[
#include "main.h"								// main wb_[
#include "player.h"								// player wb_[

/*------------------------------
 * ֐ CHARA_JOHNSON::output
 * `ʂ
------------------------------*/
void CHARA_JOHNSON::output(void)
{
	SetDrawBlendMode( DX_BLENDMODE_SUB, 255 );	// `ʂ̃uh̕ύX

	if( direction == 1 )
	{
		SetDrawBright( 0, 255, 255 );			// ԐF

		if( special == 1 )
		{
			if( ( COUNT / 60 ) % 2 )
				DrawGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_FIRE ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_FIRE ], TRUE );
		}

		switch( act )
		{
		case ACT_TACHI:							// 
			if( ( time / 15 ) % 2 )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TACHI0 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TACHI1 ], TRUE );	
			break;
		case ACT_MAESTEP:						// Oړ
			DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_MAESTEP ], TRUE );
			break;
		case ACT_BACKSTEP:						// ړ
			DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_BACKSTEP ], TRUE );
			break;
		case ACT_JAKU_KOUGEKI:					// U
			if( time < JOHNSON_JAKU_FLAME_HASSEI )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_COMMON_KAMAE ], TRUE );
			else if( time < JOHNSON_JAKU_FLAME_HASSEI + JOHNSON_JAKU_FLAME_OWARI / 2 )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU1 ], TRUE );
			break;
		case ACT_KYOU_KOUGEKI:					// U
			if( time < JOHNSON_KYOU_FLAME_HASSEI )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_COMMON_KAMAE ], TRUE );
			else if( time < JOHNSON_KYOU_FLAME_HASSEI + JOHNSON_KYOU_FLAME_OWARI / 2 )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_JOHNSON_KYOU0 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_JOHNSON_KYOU1 ], TRUE );
			break;
		case ACT_SPCL_KOUGEKI:					// KEZ
			if( time < JOHNSON_SPCL_FLAME_HASSEI )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_COMMON_KAMAE ], TRUE );
			else if( time < JOHNSON_SPCL_FLAME_HASSEI + JOHNSON_SPCL_FLAME_OWARI / 2 )
				DrawGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_JOHNSON_SPCL0 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_JOHNSON_SPCL1 ], TRUE );
			break;
		case ACT_YARARE_NORMAL:					// ꒆ
			if( time < yarare_flame / 2 )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE0 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_YARARE_SPECIAL0:				// KEꒆ
			if( time < yarare_flame / 2 )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_HISSATSUTAORE0 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_YARARE_SPECIAL1:				// KEꒆ
			if( time < yarare_flame / 2 )
				DrawGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_HISSATSUTAORE1 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_YARARE_SPECIAL2:				// KEꒆ
			if( time < yarare_flame / 2 )
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_HISSATSUTAORE2 ], TRUE );
			else
				DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_KO:							// KO
			DrawGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		default:
			break;
		}
	}
	else
	{
		SetDrawBright( 255, 255, 0 );			// F

		if( special == 1 )
		{
			if( ( COUNT / 60 ) % 2 )
				DrawTurnGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_FIRE ], TRUE );
			else
				DrawGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_FIRE ], TRUE );
		}

		switch( act )
		{
		case ACT_TACHI:							// 
			if( ( time / 15 ) % 2 )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TACHI0 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TACHI1 ], TRUE );	
			break;
		case ACT_MAESTEP:						// Oړ
			DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_MAESTEP ], TRUE );
			break;
		case ACT_BACKSTEP:						// ړ
			DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_BACKSTEP ], TRUE );
			break;
		case ACT_JAKU_KOUGEKI:					// U
			if( time < JOHNSON_JAKU_FLAME_HASSEI )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_COMMON_KAMAE ], TRUE );
			else if( time < JOHNSON_JAKU_FLAME_HASSEI + JOHNSON_JAKU_FLAME_OWARI / 2 )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU1 ], TRUE );
			break;
		case ACT_KYOU_KOUGEKI:					// U
			if( time < JOHNSON_KYOU_FLAME_HASSEI )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_COMMON_KAMAE ], TRUE );
			else if( time < JOHNSON_KYOU_FLAME_HASSEI + JOHNSON_KYOU_FLAME_OWARI / 2 )
				DrawTurnGraph( position * 60 + 235 - 150, 315, CharaGraph[ CHARAGRAPH_JOHNSON_KYOU0 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235 - 150, 315, CharaGraph[ CHARAGRAPH_JOHNSON_KYOU1 ], TRUE );
			break;
		case ACT_SPCL_KOUGEKI:					// KEZ
			if( time < JOHNSON_SPCL_FLAME_HASSEI )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_COMMON_KAMAE ], TRUE );
			else if( time < JOHNSON_SPCL_FLAME_HASSEI + JOHNSON_SPCL_FLAME_OWARI / 2 )
				DrawTurnGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_JOHNSON_SPCL0 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_JOHNSON_SPCL1 ], TRUE );
			break;
		case ACT_YARARE_NORMAL:					// ꒆ
			if( time < yarare_flame / 2 )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE0 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_YARARE_SPECIAL0:				// KEꒆ
			if( time < yarare_flame / 2 )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_HISSATSUTAORE0 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_YARARE_SPECIAL1:				// KEꒆ
			if( time < yarare_flame / 2 )
				DrawTurnGraph( position * 60 + 235, 165, CharaGraph[ CHARAGRAPH_HISSATSUTAORE1 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_YARARE_SPECIAL2:				// KEꒆ
			if( time < yarare_flame / 2 )
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_HISSATSUTAORE2 ], TRUE );
			else
				DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		case ACT_KO:							// KO
			DrawTurnGraph( position * 60 + 235, 315, CharaGraph[ CHARAGRAPH_TAORE1 ], TRUE );
			break;
		default:
			break;
		}
	}

	SetDrawBright( 255, 255, 255 );				// ݒɖ߂
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );	// `ʂ̃uh̕ύX

}

/*------------------------------
 * ֐ CHARA_JOHNSON::whileJaku
 * U̓s
------------------------------*/
void CHARA_JOHNSON::whileJaku(void)
{
	/*------------------------------
	 * U̔
	------------------------------*/
	if( time == JOHNSON_JAKU_FLAME_HASSEI )
	{
		attack = ATTACK_JOHNSON_JAKU;
		state = STATE_NORMAL;				// UߒʏԂ
	}
	/*------------------------------
	 * ̎t
	------------------------------*/
	if( time < 5 && getButtonKyou() == 1 )
		attackSpecial();
	/*------------------------------
	 * s͂̎t
	------------------------------*/
	if( JOHNSON_JAKU_FLAME_HASSEI + JOHNSON_JAKU_FLAME_OWARI - SENKOU_NYURYOKU_FLAME <= time )
		setPrecede();
	/*------------------------------
	 * ȔI
	------------------------------*/
	if( JOHNSON_JAKU_FLAME_HASSEI + JOHNSON_JAKU_FLAME_OWARI <= time )
	{
		act = ACT_TACHI;
		time = 0;

		actionPrecede();					// s͂̎s
	}
}
/*------------------------------
 * ֐ CHARA_JOHNSON::whileKyou
 * U̓s
------------------------------*/
void CHARA_JOHNSON::whileKyou(void)
{
	/*------------------------------
	 * U̔
	------------------------------*/
	if( time == JOHNSON_KYOU_FLAME_HASSEI )
	{
		attack = ATTACK_JOHNSON_KYOU;
		state = STATE_NORMAL;				// UߒʏԂ
	}
	/*------------------------------
	 * ̎t
	------------------------------*/
	if( time < 5 && getButtonJaku() == 1 )
		attackSpecial();
	/*------------------------------
	 * s͂̎t
	------------------------------*/
	if( JOHNSON_KYOU_FLAME_HASSEI + JOHNSON_KYOU_FLAME_OWARI - SENKOU_NYURYOKU_FLAME <= time )
		setPrecede();
	/*------------------------------
	 * ȔI
	------------------------------*/
	if( JOHNSON_KYOU_FLAME_HASSEI + JOHNSON_KYOU_FLAME_OWARI <= time )
	{
		act = ACT_TACHI;
		time = 0;

		actionPrecede();					// s͂̎s
	}
}
/*------------------------------
 * ֐ CHARA_JOHNSON::whileSpecial
 * KEZ̓s
------------------------------*/
void CHARA_JOHNSON::whileSpecial(void)
{
	/*------------------------------
	 * U̔
	------------------------------*/
	if( time == JOHNSON_SPCL_FLAME_HASSEI )
	{
		attack = ATTACK_JOHNSON_SPCL;
		state = STATE_NORMAL;				// UߒʏԂ
	}
	/*------------------------------
	 * s͂̎t
	------------------------------*/
	if( JOHNSON_SPCL_FLAME_HASSEI + JOHNSON_SPCL_FLAME_OWARI - SENKOU_NYURYOKU_FLAME <= time )
		setPrecede();
	/*------------------------------
	 * KEZ̏I
	------------------------------*/
	if( JOHNSON_SPCL_FLAME_HASSEI + JOHNSON_SPCL_FLAME_OWARI <= time )
	{
		act = ACT_TACHI;
		time = 0;

		actionPrecede();					// s͂̎s
	}
}

/*------------------------------
 * ֐ CHARA_JOHNSON::attackJaku
 * Us
------------------------------*/
void CHARA_JOHNSON::attackJaku(void)
{
	act = ACT_JAKU_KOUGEKI;
	time = 0;
	state = STATE_ATTACK;					// U
}
/*------------------------------
 * ֐ CHARA_JOHNSON::attackKyou
 * Us
------------------------------*/
void CHARA_JOHNSON::attackKyou(void)
{
	act = ACT_KYOU_KOUGEKI;
	time = 0;
	state = STATE_ATTACK;					// U
}
/*------------------------------
 * ֐ CHARA_JOHNSON::attackSpecial
 * KEZs
------------------------------*/
void CHARA_JOHNSON::attackSpecial(void)
{
	if( special != 1 ) return;				// KEZĂȂ

	act = ACT_SPCL_KOUGEKI;
	time = 0;

	state = STATE_ATTACK;					// U

	special = -1;							// KEZ͌ĂȂ
}

/*------------------------------
 * ֐ CHARA_JOHNSON::getOwnInitHP
 * LƂ̗̏͂Ԃ
------------------------------*/
int CHARA_JOHNSON::getOwnInitHP(void)
{
	return JOHNSON_HITPOINT;
}
/*------------------------------
 * ֐ CHARA_JOHNSON::getOwnInitHP
 * KEZs
------------------------------*/
char* CHARA_JOHNSON::getOwnName(void)
{
	return "JOHNSON";
}