/*------------------------------
 *
 * iQ[
 *
 * main R[h
 * Q[̒S
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define MAIN_H									// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[
#include "main.h"								// main wb_[
#include "player.h"								// player wb_[
#include "stage.h"								// stage wb_[

#include "fight.h"								// fight wb_[
#include "select.h"								// select wb_[
#include "fps.h"								// fps wb_[
#include "key.h"								// key wb_[
#include "myrand.h"								// myrand wb_[

#include <io.h>									// for filefind
#include <string.h>								// for strcmp
#include <time.h>

/*------------------------------
 * LOCAL PARAMETER
------------------------------*/
int *BGM = NULL;								// BGM
int BGM_num;

int FULLSCREEN_FLAG;							// tXN[ɂ邩ۂ

/*------------------------------
 * ֐ WinMain
 * vO WinMain n܂܂
------------------------------*/
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
						LPSTR lpCmdLine, int nCmdShow )
{
	/*------------------------------
	 * R}hC̓ǂݍ
	------------------------------*/
	FULLSCREEN_FLAG = TRUE;
	for(int i=1;i<__argc;i++)
		if( strcmp( "-window", __argv[i] ) == 0 )
			FULLSCREEN_FLAG = FALSE;

	/*------------------------------
	 * DXCȕ
	------------------------------*/
	SetOutApplicationLogValidFlag( FALSE );		// Ȍo͂sȂ									

	SetGraphMode( WINDOW_WIDTH , WINDOW_HEIGHT , 32 );
												// EBhȆ傫̎w

	if( !FULLSCREEN_FLAG )
		ChangeWindowMode( TRUE );				// EBhE[hŋN

	SetMainWindowText( WINDOW_TITLE );			// ^Cg̐ݒ

	if( DxLib_Init() == -1 )					// DXCu
	{
		return -1;								// G[N璼ɏI
	}

	SetAlwaysRunFlag( TRUE );					// EBhEANeBûƂł悤ɂB

	SetDrawScreen( DX_SCREEN_BACK );			// ʂ̕`ʐ𗠂ɐݒ

	gameMain();									// Q[̌Ăяo

	DxLib_End();								// cwCugp̏I

	return 0;									// \tg̏I 
}

/*------------------------------
 * ֐ gameMain
 * Q[̒
------------------------------*/
void gameMain(void)
{
	gameInit();									// Q[̏

	while( 1 )
	{
		getWaitTime();							// ҂ԎZo

		// bZ[W[vɑ鏈
		if( ProcessMessage() == -1 )
		{
			break;								// G[N烋[v𔲂
		}

		checkMouseState();						// }EX̏Ԃ擾B
		checkKeyState();						// L[̓͏Ԃ̎擾B

		if( getKeyState( KEY_INPUT_ESCAPE ) )	// EscapeL[ŏI
			break;

		/*------------------------------
		 * Q[vC̏
		------------------------------*/

		switch( game_state )
		{
		case GAME_TITLE:
			if( getKeyState( KEY_INPUT_W ) == 1 || getKeyState( KEY_INPUT_UP ) == 1 )
			{
				game_state = GAME_SELECT;		// {^ZNgʂ
				select_->start();
				PlaySoundMem( SE[ SE_DECIDE ] , DX_PLAYTYPE_BACK );
				playSelectBGM();
			}
			DrawBox( 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0xffffff, TRUE );
			DrawBox( 0, 0, WINDOW_WIDTH, 75, 0x000000, TRUE );
			DrawBox( 0, WINDOW_HEIGHT - 75, WINDOW_WIDTH, WINDOW_HEIGHT, 0x000000, TRUE );
												// ʂ̏
			if( ( COUNT / 30 ) % 3 )			// ^Cg̕`
			{
				DrawFormatStringToHandle( 230, 225, 0xffb0b0, FONT_HANDLE3, "SUPER" );
				DrawFormatStringToHandle( 230, 275, 0xffffff, FONT_HANDLE3, "SIMPLE" );
				DrawFormatStringToHandle( 230, 325, 0xffffff, FONT_HANDLE3, "FIGHTER" );

				DrawFormatStringToHandle( 500, 450, 0xffffff, FONT_HANDLE2, "Version2.21" );
			}
			ScreenFlip();	
			break;
		case GAME_SELECT:
			select_->update();					// Abvf[g
			DrawBox( 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0xffffff, TRUE );
			DrawBox( 0, 0, WINDOW_WIDTH, 75, 0x000000, TRUE );
			DrawBox( 0, WINDOW_HEIGHT - 75, WINDOW_WIDTH, WINDOW_HEIGHT, 0x000000, TRUE );
												// ʂ̏
			select_->output();					// o
			ScreenFlip();						// ʂɔf
			break;
		case GAME_PLAYING:
			fight->update();						// Abvf[g
			DrawBox( 0, 0, WINDOW_WIDTH, WINDOW_HEIGHT, 0xffffff, TRUE );
			DrawBox( 0, 0, WINDOW_WIDTH, 75, 0x000000, TRUE );
			DrawBox( 0, WINDOW_HEIGHT - 75, WINDOW_WIDTH, WINDOW_HEIGHT, 0x000000, TRUE );
												// ʂ̏
			fight->output();					// o
			ScreenFlip();						// ʂɔf
			break;
		default:
			break;
		}

		/*------------------------------
		 * Q[vC̏܂
		------------------------------*/

		if( COUNT == ULONG_MAX )				// I[o[t[΍
			COUNT = 0;
		else
			COUNT++;							// JEgAbv

		fpsTimeFunction();						// FPS̎Zo
		wait();		
	}

	gameFinal();								// Q[̏I
}

/*------------------------------
 * ֐ gameInit
 * Q[̏
------------------------------*/
void gameInit(void)
{
	COUNT = 0;									// Q[JEg̏
	game_state = GAME_TITLE;					// ^Cgʂɐݒ

	loadCharaGraph();							// L̉摜̃[h
	loadStageGraph();							// Xe[W̉摜̃[h

	loadFAMania();								// FAManiatHg̃[h
	loadFontHandle();							// tHgnh̃[h

	loadBGM();									// TEh̃[h
	loadSE();

	fight = new FIGHT();
	select_ = new SELECT();

	select_->init();

	MTInit( (unsigned)time(NULL) );				// MTɎ^
}

/*------------------------------
 * ֐ gameFinal
 * Q[̏IɌĂяo
------------------------------*/
void gameFinal(void)
{
	unloadCharaGraph();							// L̉摜̃A[h
	unloadStageGraph();							// Xe[W摜̃A[h

	unloadFAMania();							// tHg̃A[h

	unloadBGM();								// TEh̃A[h
	unloadSE();

	fight->unloadChara();						// L̃A[h
	fight->unloadStage();						// Xe[W̃A[h
	delete fight;

	delete select_;
}

/*------------------------------
 * ֐ loadFAMania,unload
 * tHg̓ǂݍ
------------------------------*/
LPCSTR font_path;								// tHg̃pX
void loadFAMania(void)
{
	font_path = "font/FAMania/FAMania2.6.TTF";
												// ǂݍރtHgt@C̃pX
	if (AddFontResourceEx(font_path, FR_PRIVATE, NULL) > 0)
	{
	}
	else
	{
		MessageBox(NULL,"tHgǍs","",MB_OK);
												// tHgǍG[
	}
}
void unloadFAMania(void)
{
	if (RemoveFontResourceEx(font_path, FR_PRIVATE, NULL))
	{
	}
	else
	{
		MessageBox(NULL, "remove failure", "", MB_OK);
	}
}

/*------------------------------
 * ֐ loadFontHandle
 * gptHgnh̃[h
------------------------------*/
void loadFontHandle(void)
{
	FONT_HANDLE1 = CreateFontToHandle( "FAMania", 16, 1, DX_FONTTYPE_EDGE, -1, 1 );
	FONT_HANDLE2 = CreateFontToHandle( "FAMania", 20, 1, DX_FONTTYPE_EDGE, -1, 2 );
	FONT_HANDLE3 = CreateFontToHandle( "FAMania", 40, 1, DX_FONTTYPE_EDGE, -1, 2 );
	FONT_HANDLE4 = CreateFontToHandle( "FAMania", 80, 1, DX_FONTTYPE_EDGE, -1, 4 );
}

/*------------------------------
 * ֐ loadBGM, unload
 * BGM̃[h, A[h
------------------------------*/
void loadBGM(void)
{
	if( !BGM )
		BGM = new int[50];

	for(int i=0;i<50;i++)
		BGM[ i ] = -1;

	SetCreateSoundDataType( DX_SOUNDDATATYPE_FILE ) ;
											// BGM̓Xg[~OĐ(Ăяo)Ƃɂ

	struct _finddata_t c_file;
	long   hFile;

	BGM_num = 0;
	char file_path[256];

	/*------------------------------
	 * sound/bgm fBNgmp3t@CT܂B
	------------------------------*/
	if( (hFile = _findfirst( "sound/bgm/*.mp3", &c_file )) == -1L )
	{
		/*------------------------------
		 * t@CȂƂ
		------------------------------*/
	}
	else
	{
		/*------------------------------
		 * t@CI
		------------------------------*/	
		// t@CpX̎Zo
		strcpy( file_path, "sound/bgm/" );
		strcat( file_path, c_file.name );

		// t@C̓ǂݍ
		BGM[ BGM_num ] = LoadSoundMem( file_path );
		// ʒ
		ChangeVolumeSoundMem( 256 * 5 / 100, BGM[ BGM_num ] );

		// JE^
		BGM_num++;

		// c̃t@CT܂
		while( _findnext( hFile, &c_file ) == 0 )
		{
			// t@CpX̎Zo
			strcpy( file_path, "sound/bgm/" );
			strcat( file_path, c_file.name );

			// t@C̓ǂݍ
			BGM[ BGM_num ] = LoadSoundMem( file_path );
			// ʒ
			ChangeVolumeSoundMem( 256 * 5 / 100, BGM[ BGM_num ] );

			// JE^
			BGM_num++;

			if( BGM_num >= 50 ) break;
		}

		_findclose( hFile );
	}
	/*------------------------------
	 * sound/bgm fBNgoggt@CT܂B
	------------------------------*/
	if( (hFile = _findfirst( "sound/bgm/*.ogg", &c_file )) == -1L )
	{
		/*------------------------------
		 * t@CȂƂ
		------------------------------*/
	}
	else
	{
		/*------------------------------
		 * t@CI
		------------------------------*/	
		// t@CpX̎Zo
		strcpy( file_path, "sound/bgm/" );
		strcat( file_path, c_file.name );

		// t@C̓ǂݍ
		BGM[ BGM_num ] = LoadSoundMem( file_path );
		// ʒ
		ChangeVolumeSoundMem( 256 * 5 / 100, BGM[ BGM_num ] );

		// JE^
		BGM_num++;

		// c̃t@CT܂
		while( _findnext( hFile, &c_file ) == 0 )
		{
			// t@CpX̎Zo
			strcpy( file_path, "sound/bgm/" );
			strcat( file_path, c_file.name );

			// t@C̓ǂݍ
			BGM[ BGM_num ] = LoadSoundMem( file_path );
			// ʒ
			ChangeVolumeSoundMem( 256 * 5 / 100, BGM[ BGM_num ] );

			// JE^
			BGM_num++;

			if( BGM_num >= 50 ) break;
		}

		_findclose( hFile );
	}
}
void unloadBGM(void)
{
	for(int i=0;i<BGM_num;i++)
	{
		if( BGM[ i ] != -1 )
			DeleteSoundMem( BGM[ i ] );
	}

	if( BGM )
	{
		delete [] BGM;	// |C^w
		BGM = NULL;
		BGM_num = 0;
	}
}

/*------------------------------
 * ֐ loadSE, unloadSE
 * ʉ̃[h, A[h
------------------------------*/
void loadSE(void)
{
	SetCreateSoundDataType( DX_SOUNDDATATYPE_MEMNOPRESS ) ;
											// SE͊Sɓǂݍݐ؂

	SE = new int[50];

	for(int i=0;i<50;i++)
		SE[ i ] = -1;

	// {CX
	SE[ SE_DOUBLEKO ] =		LoadSoundMem( "sound/se/voice/doubleKO.wav" );
	SE[ SE_FIGHT ] =		LoadSoundMem( "sound/se/voice/fight.wav" );
	SE[ SE_FINALROUND ] =	LoadSoundMem( "sound/se/voice/finalround.wav" );
	SE[ SE_KO ] =			LoadSoundMem( "sound/se/voice/KO.wav" );
	SE[ SE_ROUND1 ] =		LoadSoundMem( "sound/se/voice/round1.wav" );
	SE[ SE_ROUND2 ] =		LoadSoundMem( "sound/se/voice/round2.wav" );
	SE[ SE_ROUND3 ] =		LoadSoundMem( "sound/se/voice/round3.wav" );
	SE[ SE_ROUND4 ] =		LoadSoundMem( "sound/se/voice/round4.wav" );
	SE[ SE_ROUND5 ] =		LoadSoundMem( "sound/se/voice/round5.wav" );
	SE[ SE_ROUND6 ] =		LoadSoundMem( "sound/se/voice/round6.wav" );
	SE[ SE_ROUND7 ] =		LoadSoundMem( "sound/se/voice/round7.wav" );
	SE[ SE_ROUND8 ] =		LoadSoundMem( "sound/se/voice/round8.wav" );
	SE[ SE_REDWIN ] =		LoadSoundMem( "sound/se/voice/redwin.wav" );
	SE[ SE_BLUEWIN ] =		LoadSoundMem( "sound/se/voice/bluewin.wav" );
	SE[ SE_TIMEUP ] =		LoadSoundMem( "sound/se/voice/timeup.wav" );
	SE[ SE_PERFECT ] =		LoadSoundMem( "sound/se/voice/perfect.wav" );

	// U, ̑
	SE[ SE_JAKUPUNCH ] =	LoadSoundMem( "sound/se/attack/jakuPunch.wav" );
	SE[ SE_JAKUKICK ] =		LoadSoundMem( "sound/se/attack/jakuKick.wav" );
	SE[ SE_KYOUPUNCH ] =	LoadSoundMem( "sound/se/attack/kyouPunch.wav" );
	SE[ SE_KYOUKICK ] =		LoadSoundMem( "sound/se/attack/kyouKick.wav" );
	SE[ SE_BINTA ] =		LoadSoundMem( "sound/se/attack/binta.wav" );
	SE[ SE_SHOT ] =			LoadSoundMem( "sound/se/attack/shot.wav" );
	SE[ SE_SPDAGEKI ] =		LoadSoundMem( "sound/se/attack/spDageki.wav" );
	SE[ SE_HADOU ] =		LoadSoundMem( "sound/se/attack/hadou.wav" );
	SE[ SE_EXPLOSION ] =	LoadSoundMem( "sound/se/attack/explosion.wav" );
	SE[ SE_FIRE ] =			LoadSoundMem( "sound/se/attack/fire.wav" );
	SE[ SE_STEP ] =			LoadSoundMem( "sound/se/attack/step.wav" );

	// ZNg
	SE[ SE_CURSOR ] =		LoadSoundMem( "sound/se/select/cursor.wav" );
	SE[ SE_DECIDE ] =		LoadSoundMem( "sound/se/select/decide.wav" );

	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_JAKUPUNCH ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_JAKUKICK ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_KYOUPUNCH ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_KYOUKICK ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_BINTA ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_SHOT ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_SPDAGEKI ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_HADOU ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_EXPLOSION ] );
	ChangeVolumeSoundMem( 256 * 25 / 100, SE[ SE_FIRE ] );
	ChangeVolumeSoundMem( 256 * 5 / 100, SE[ SE_STEP ] );
	ChangeVolumeSoundMem( 256 * 5 / 100, SE[ SE_CURSOR ] );
	ChangeVolumeSoundMem( 256 * 5 / 100, SE[ SE_DECIDE ] );

}
void unloadSE(void)
{
	if( !SE) return;

	for(int i=0;i<50;i++)
	{
		if( SE[ i ] != -1 )
			DeleteSoundMem( SE[ i ] );
	}

	delete [] SE;	// |C^w
	SE = NULL;
}

/*------------------------------
 * ֐ playRandomBGM, playSelectBGM, stopBGM
 * BGM̍Đƒ~
------------------------------*/
void playRandomBGM(void)
{
	if( BGM_num > 1 )
		PlaySoundMem( BGM[ getIntRand( 1, BGM_num - 1 ) ], DX_PLAYTYPE_LOOP );
}
void playSelectBGM(void)
{
	if( BGM_num > 0 )
		PlaySoundMem( BGM[ 0 ], DX_PLAYTYPE_LOOP );
}
void stopBGM(void)
{
	for(int i=0;i<BGM_num;i++)
		StopSoundMem( BGM[ i ] );	
}