/*------------------------------
 *
 * iQ[
 *
 * select wb_[
 * ZNg̊ǗS
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define SELECT_H								// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[

#include "main.h"								// main wb_[
#include "player.h"								// player wb_[
#include "stage.h"								// stage wb_[
#include "fight.h"								// fight wb_[


#include "select.h"								// stage wb_[

#include "key.h"								// key wb_[

/*------------------------------
 * ֐ SELECT::init
 * ZNg̏
------------------------------*/
void SELECT::init(void)
{
	state = SELECT_CHARA;

	p1Chara = CHARA_NAME_RANDOM;
	p2Chara = CHARA_NAME_RANDOM;

	p1Decision = p2Decision = FALSE;

	stage = STAGE_RANDOM;
}

/*------------------------------
 * ֐ SELECT::start
 * ZNg̏
------------------------------*/
void SELECT::start(void)
{
	state = SELECT_CHARA;

	p1Decision = p2Decision = FALSE;
}

/*------------------------------
 * ֐ SELECT::update
 * ZNg̍XV
------------------------------*/
void SELECT::update(void)
{
	switch( state )
	{
	case SELECT_CHARA:
		/*------------------------------
		 * LN^[ZNg
		------------------------------*/
		/*------------------------------
		 * 1P
		------------------------------*/
		if( !p1Decision )						// ߂ĂƂ͂Ȃ
		{
			if( getKeyState( KEY_INPUT_A ) == 1 )
			{
				p1Chara = ( p1Chara + CHARA_NUM - 1 ) % CHARA_NUM;
				PlaySoundMem( SE[ SE_CURSOR ] , DX_PLAYTYPE_BACK );
			}
			if( getKeyState( KEY_INPUT_D ) == 1 )
			{
				p1Chara = ( p1Chara + 1 ) % CHARA_NUM;
				PlaySoundMem( SE[ SE_CURSOR ] , DX_PLAYTYPE_BACK );
			}
			if( getKeyState( KEY_INPUT_W ) == 1 ) 
			{
				p1Decision = TRUE;				// 
				PlaySoundMem( SE[ SE_DECIDE ] , DX_PLAYTYPE_BACK );
			}
		}
		/*------------------------------
		 * 2P
		------------------------------*/
		if( !p2Decision )						// ߂ĂƂ͂Ȃ
		{
			if( getKeyState( KEY_INPUT_LEFT ) == 1 )
			{
				p2Chara = ( p2Chara + CHARA_NUM - 1 ) % CHARA_NUM;
				PlaySoundMem( SE[ SE_CURSOR ] , DX_PLAYTYPE_BACK );
			}
			if( getKeyState( KEY_INPUT_RIGHT ) == 1 )
			{
				p2Chara = ( p2Chara + 1 ) % CHARA_NUM;
				PlaySoundMem( SE[ SE_CURSOR ] , DX_PLAYTYPE_BACK );
			}
			if( getKeyState( KEY_INPUT_UP ) == 1 ) 
			{
				p2Decision = TRUE;				// 
				PlaySoundMem( SE[ SE_DECIDE ] , DX_PLAYTYPE_BACK );
			}
		}

		if( p1Decision && p2Decision )			// lƂ܂Ύ
			state = SELECT_STAGE;
		break;
	case SELECT_STAGE:
		/*------------------------------
		 * Xe[WZNg
		------------------------------*/
		// 1P݂̂̑
		if( getKeyState( KEY_INPUT_A ) == 1 )
		{
			stage = ( stage + STAGE_NUM - 1 ) % STAGE_NUM;
			PlaySoundMem( SE[ SE_CURSOR ] , DX_PLAYTYPE_BACK );
		}
		if( getKeyState( KEY_INPUT_D ) == 1 )
		{
			stage = ( stage + 1 ) % STAGE_NUM;
			PlaySoundMem( SE[ SE_CURSOR ] , DX_PLAYTYPE_BACK );
		}
		if( getKeyState( KEY_INPUT_W ) == 1 ) 
		{
			game_state = GAME_PLAYING;		// Xe[WIn܂
			fight->loadChara( p1Chara, p2Chara );	// LN^̃[h
			fight->loadStage( stage );		// Xe[W̃[h
			fight->init();					// 
			PlaySoundMem( SE[ SE_DECIDE ] , DX_PLAYTYPE_BACK );
			stopBGM();						// ZNgBGM̒~
			playRandomBGM();				// BGM̍Đ
		}
		break;
	default:
		break;
	}

	if( getKeyState( KEY_INPUT_R ) == 1 )
	{
		game_state = GAME_TITLE;		// {^n܂
		stopBGM();						// BGM̒~
	}
}

/*------------------------------
 * ֐ SELECT::output
 * ZNg̕`
------------------------------*/
const char CHARA_ICON[CHARA_NUM] = { 'M', 'I', 'T', 'K', 'J', 'G', '?', 'W', 'L', 'N', 'Y', 'H', 'C' };
void SELECT::output(void)
{
	switch( state )
	{
	case SELECT_CHARA:
		/*------------------------------
		 * LN^[ZNg
		------------------------------*/
		/*------------------------------
		 * "CHARACTER SELECT"̕\
		------------------------------*/
		DrawFormatStringToHandle(  10,  85, 0xffffff, FONT_HANDLE2, "CHARACTER SELECT" );

		/*------------------------------
		 * LN^[̕\
		------------------------------*/
		SetDrawBlendMode( DX_BLENDMODE_SUB, 255 );	// `ʂ̃uh̕ύX
		SetDrawBright( 0, 255, 255 );			// ԐF

		switch( p1Chara )
		{
		case CHARA_NAME_TAKASHI:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_KENTA:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_KENTA_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_JOHNSON:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_JOHNSON_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_JOHNSON_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_GARCIA:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_GARCIA_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_GARCIA_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_GARCIA_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_WANG:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_WANG_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_WANG_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_WANG_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_LYNDEM:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_LYNDEM_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_LYNDEM_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_LYNDEM_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_NGUYEN:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_NGUYEN_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_NGUYEN_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_NGUYEN_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_YUKO:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_YUKO_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_YUKO_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_HECKLER:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_HECKLER_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_HECKLER_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_HECKLER_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_ICHI:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_KENTA_SPCL0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_ICHI_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235 - 75, 165 - 75, CharaGraph[ CHARAGRAPH_ICHI_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_COX:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_LYNDEM_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_COX_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_COX_SPCL1 ], TRUE );
			break;
		case CHARA_NAME_MICHAEL:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_MICHAEL_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_MICHAEL_KYOU0 ], TRUE );
			else
				DrawGraph( -2 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_MICHAEL_SPCL1 ], TRUE );
			break;
		default:
			break;
		}

		SetDrawBright( 255, 255, 0 );			// F

		switch( p2Chara )
		{
		case CHARA_NAME_TAKASHI:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_TAKASHI_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_TAKASHI_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_KENTA:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_TAKASHI_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_KENTA_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_JOHNSON:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_JOHNSON_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_JOHNSON_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_GARCIA:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_GARCIA_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_GARCIA_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_GARCIA_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_WANG:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_WANG_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_WANG_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_WANG_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_LYNDEM:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_LYNDEM_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_LYNDEM_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_LYNDEM_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_NGUYEN:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_NGUYEN_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_NGUYEN_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_NGUYEN_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_YUKO:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_YUKO_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_YUKO_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_TAKASHI_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_HECKLER:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_HECKLER_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_HECKLER_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_HECKLER_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_ICHI:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 15, CharaGraph[ CHARAGRAPH_KENTA_SPCL0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235 - 150, 165, CharaGraph[ CHARAGRAPH_ICHI_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235 - 75, 165 - 75, CharaGraph[ CHARAGRAPH_ICHI_SPCL0 ], TRUE );
			break;
		case CHARA_NAME_COX:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_LYNDEM_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_COX_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_COX_SPCL1 ], TRUE );
			break;
		case CHARA_NAME_MICHAEL:
			if( ( COUNT / 60 ) % 3 == 0 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_MICHAEL_JAKU0 ], TRUE );
			else if( ( COUNT / 60 ) % 3 == 1 )
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_MICHAEL_KYOU0 ], TRUE );
			else
				DrawTurnGraph( 5 * 60 + 235, 165, CharaGraph[ CHARAGRAPH_MICHAEL_SPCL1 ], TRUE );
			break;
		default:
			break;
		}

		SetDrawBright( 255, 255, 255 );				// ݒɖ߂
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 255 );	// `ʂ̃uh̕ύX

		/*------------------------------
		 * LN^[̖O̕\
		------------------------------*/
		if( p1Decision )
			DrawFormatStringToHandle(  50, 140, 0xff8080, FONT_HANDLE3, "%s", CHARA_NAME_CHAR[ p1Chara ] );
		else
			DrawFormatStringToHandle(  50, 140, 0xffffff, FONT_HANDLE3, "%s", CHARA_NAME_CHAR[ p1Chara ] );
		if( p2Decision )
			DrawFormatStringToHandle( 450, 140, 0x8080ff, FONT_HANDLE3, "%s", CHARA_NAME_CHAR[ p2Chara ] );
		else
			DrawFormatStringToHandle( 450, 140, 0xffffff, FONT_HANDLE3, "%s", CHARA_NAME_CHAR[ p2Chara ] );

		/*------------------------------
		 * LN^[̑IACR̕\
		 * ĕ
		------------------------------*/
		for(int i=0;i<CHARA_NUM;i++)
			DrawBox( 12 + i*60, 392, 68 + i*60, 448, 0x000000, FALSE );
		for(int i=0;i<CHARA_NUM;i++)
			DrawFormatStringToHandle( 12 + i*60 + 6, 392 + 4, 0xffffff, FONT_HANDLE3, "%c", CHARA_ICON[ i ] );

		/*------------------------------
		 * ǂ̃LIĂ邩\
		------------------------------*/
		DrawFormatStringToHandle( 12 + p1Chara*60 + 5, 392 - 20, 0xff8080, FONT_HANDLE2, "1P" );
		DrawFormatStringToHandle( 12 + p2Chara*60 + 5, 392 + 50, 0x8080ff, FONT_HANDLE2, "2P" );

		/*------------------------------
		 * _Ŗ̕\
		------------------------------*/
		if( ( COUNT / 30 ) % 3 )
		{
			DrawFormatStringToHandle(  42 + 6, 332 + 4, 0xffffff, FONT_HANDLE3, "" );
			DrawFormatStringToHandle( 702 + 6, 452 + 4, 0xffffff, FONT_HANDLE3, "" );
		}

		break;

	case SELECT_STAGE:
		/*------------------------------
		 * Xe[WZNg
		------------------------------*/

		/*------------------------------
		 * Xe[W̕\
		------------------------------*/
		switch( stage )
		{
		case STAGE_HITOGOMI:
		case STAGE_STREET:
		case STAGE_DEFAULT:
		case STAGE_FOREST:
			DrawGraph( 0, 75, StageGraph[ stage ], TRUE );
			break;
		default:
			break;
		}

		/*------------------------------
		 * "STAGE SELECT"̕\
		------------------------------*/
		DrawFormatStringToHandle(  10,  85, 0xffffff, FONT_HANDLE2, "STAGE SELECT" );

		/*------------------------------
		 * Xe[W̖O̕\
		------------------------------*/
		DrawFormatStringToHandle(  10, 270, 0xffffff, FONT_HANDLE3, "%s", STAGE_NAME_CHAR[ stage ] );

		/*------------------------------
		 * ̕\
		------------------------------*/
		if( ( COUNT / 30 ) % 3 )
		{
			DrawFormatStringToHandle( 10, 210, 0xffffff, FONT_HANDLE3, "" );
			DrawFormatStringToHandle( 10, 330, 0xffffff, FONT_HANDLE3, "" );
		}

		break;
	default:
		break;
	}
}