/*------------------------------
 *
 * iQ[
 *
 * fight wb_[
 * vC[̊ǗS
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define FIGHT_H									// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// DxLib wb_[

#include "main.h"								// main wb_[
#include "player.h"								// player wb_[
#include "stage.h"								// stage wb_[

#include "fight.h"								// fight wb_[
#include "key.h"								// key wb_[
#include "myrand.h"								// myrand wb_[

/*------------------------------
 * ֐ FIGHT::init
 * FIGHT̏s
------------------------------*/
void FIGHT::init(void)
{
	player1->init(1); player2->init(-1);

	state = FIGHT_STARTING;
	time = -1;
	round = 1;
	p1Point = 0; p2Point = 0;
	remain = FIGHTING_TIME;
}

/*------------------------------
 * ֐ FIGHT::update
 * FIGHT̃Abvf[gs
------------------------------*/
void FIGHT::update(void)
{
	switch( state )
	{
	case FIGHT_STARTING:
		time++;									// Ԍo
		master();								// ̃}X^[

		if( time >= 170 )						// s͂̎t
		{
			player1->setPrecede();
			player2->setPrecede();
		}
		if( time >= 60 * 3 )
		{
			state = FIGHTING;
			time = 0;

			player1->setCantMove( FALSE );		// 悤ɂ
			player2->setCantMove( FALSE );
			player1->setNoDamage( FALSE );		// _[W炤悤ɂ
			player2->setNoDamage( FALSE );

			player1->actionPrecede();			// s͂̎s
			player2->actionPrecede();
		}
		break;
	case FIGHTING:
		time++;									// Ԍo
		remain--;								// c莞

		master();								// ̃}X^[
		check();								// KO⎞Ԑ؂Ȃǂ̔
		break;
	case FIGHT_KO:
		time++;
		master();

		if( time >= 60 * 2 )
			goNextRound();
		break;
	case FIGHT_DOUBLEKO:
		time++;
		master();

		if( time >= 60 * 4 )
			goNextRound();
		break;
	case FIGHT_TIMEUP:
		time++;
		master();

		if( time >= 60 * 4 )
			goNextRound();
		break;
	case FIGHT_END:
		time++;
		master();

		if( time >= 60 * 4 )
		{
			// Q[̏I
			game_state = GAME_TITLE;
			stopBGM();
		}
		break;
	}

	if( getKeyState( KEY_INPUT_R ) == 1 )
	{
		game_state = GAME_TITLE;		// {^n܂
		stopBGM();						// BGM̒~
	}
}
/*------------------------------
 * ֐ FIGHT::draw
 * `ʂs
------------------------------*/
void FIGHT::output(void)
{
	/*------------------------------
	 * Xe[W̕`
	------------------------------*/
	/*
	for(int i=0;i<10;i++)
		DrawBox( 102 + i*60, 542-75, 158 + i*60, 598-75, 0xb0b0b0, TRUE );
	*/
	stage->output();

	/*------------------------------
	 * vC[̕`
	------------------------------*/
	player1->output();player2->output();

	/*------------------------------
	 * HP̕\
	------------------------------*/
	DrawBox( 50 - 2, 100 - 2, 340 + 2, 135 + 2, 0x000000, TRUE );
	DrawBox( 340 - (int)( player1->getHPsubf() * 290 ), 100 , 340 , 135 , 0x804040, TRUE );
	DrawBox( 340 - (int)( player1->getHPf() * 290 ), 100 , 340 , 135 , 0xff8080, TRUE );
	DrawBox( 460 - 2 , 100 - 2 , 750 + 2, 135 + 2, 0x000000, TRUE );
	DrawBox( 460 , 100 , 460 + (int)( player2->getHPsubf() * 290 ) , 135 , 0x404080, TRUE );
	DrawBox( 460 , 100 , 460 + (int)( player2->getHPf() * 290 ) , 135 , 0x8080ff, TRUE );

	/*------------------------------
	 * LN^̕\
	------------------------------*/
	DrawFormatStringToHandle(  50, 140, 0xffb0b0, FONT_HANDLE1, "%s", player1->getOwnName() );
	DrawFormatStringToHandle( 750 - 160, 140, 0xb0b0ff, FONT_HANDLE1, "%10s", player2->getOwnName() );


	/*------------------------------
	 * c莞Ԃ̕\
	------------------------------*/
	if( ( remain + 59 ) / 60 <= 9 )
		DrawFormatStringToHandle( 380, 15 + 75, 0xff0000, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );
	else if( ( remain + 59 ) / 60 <= 10 )
		DrawFormatStringToHandle( 357, 15 + 75, 0xff0000, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );
	else
		DrawFormatStringToHandle( 357, 15 + 75, 0xffffff, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );

	/*------------------------------
	 * vC[TCh̕\
	------------------------------*/

	/*------------------------------
	 * KO̕\
	------------------------------*/
	for(int i=0;i<NANBON;i++)
		DrawFormatStringToHandle( 320 - i * 24, 140, 0x808080, FONT_HANDLE2, "" );
	for(int i=0;i<NANBON;i++)
		DrawFormatStringToHandle( 456 + i * 24, 140, 0x808080, FONT_HANDLE2, "" );
	for(int i=0;i<p1Point;i++)
		DrawFormatStringToHandle( 320 - i * 24, 140, 0xffff00, FONT_HANDLE2, "" );
	for(int i=0;i<p2Point;i++)
		DrawFormatStringToHandle( 456 + i * 24, 140, 0xffff00, FONT_HANDLE2, "" );

	/*------------------------------
	 * ROUND 1̕\
	------------------------------*/
	if( state == FIGHT_STARTING )
	{
		if(  0 <= time && time < 60  )
		{
			if( p1Point == NANBON - 1 && p2Point == NANBON - 1 )
			{
				DrawStringToHandle( 180, 200, "FINAL", 0x80ff80, FONT_HANDLE4 );
				DrawStringToHandle( 180, 300, "ROUND", 0x80ff80, FONT_HANDLE4 );
			}
			else
				DrawFormatStringToHandle( 120, 250, 0xffffff, FONT_HANDLE4, "ROUND %d", round );
		}
		if( 90 <= time && time < 130 )
			DrawFormatStringToHandle( 185, 250, 0xffffff, FONT_HANDLE4, "READY");
		if(140 <= time && time < 180 )
			DrawFormatStringToHandle( 150, 250, 0xffff00, FONT_HANDLE4, "FIGHT!");

		/*------------------------------
		 * ROUND 1̉
		------------------------------*/
		if( time == 0 )
		{
			if( p1Point == NANBON - 1 && p2Point == NANBON - 1 )
				PlaySoundMem( SE[ SE_FINALROUND ] , DX_PLAYTYPE_BACK );
			else
				PlaySoundMem( SE[ round ] , DX_PLAYTYPE_BACK );
		}
		if( time == 140 )
			PlaySoundMem( SE[ SE_FIGHT ] , DX_PLAYTYPE_BACK );
	}
	else if( state == FIGHT_KO )
	{
		if( player1->getHP() == player1->getOwnInitHP() || player2->getHP() == player2->getOwnInitHP() )
			DrawStringToHandle( 95, 250, "PERFECT", 0xffff00, FONT_HANDLE4 );
		else
			DrawStringToHandle( 270, 250, "K.O.", 0xffffff, FONT_HANDLE4 );

		/*------------------------------
		 * KO, PERFECT, GREAT̉
		------------------------------*/
		if( time == 0 )
		{
			if( player1->getHP() == player1->getOwnInitHP() || player2->getHP() == player2->getOwnInitHP() )
				PlaySoundMem( SE[ SE_PERFECT ] , DX_PLAYTYPE_BACK );
			else
				PlaySoundMem( SE[ SE_KO ] , DX_PLAYTYPE_BACK );
		}
	}
	else if( state == FIGHT_DOUBLEKO )
	{
		DrawStringToHandle( 140, 200, "DOUBLE", 0x80ff80, FONT_HANDLE4 );
		DrawStringToHandle( 270, 300, "K.O.", 0x80ff80, FONT_HANDLE4 );

		/*------------------------------
		 * DOUBLE KỎ
		------------------------------*/
		if( time == 0 )
			PlaySoundMem( SE[ SE_DOUBLEKO ] , DX_PLAYTYPE_BACK );
	}
	else if( state == FIGHT_TIMEUP )
	{
		DrawStringToHandle( 120, 250, "TIME UP", 0x80ffff, FONT_HANDLE4 );

		/*------------------------------
		 * TIME UP̉
		------------------------------*/
		if( time == 0 )
			PlaySoundMem( SE[ SE_TIMEUP ] , DX_PLAYTYPE_BACK );

		/*------------------------------
		 * ^CAbv̗̑͒l̋̓IȐl\
		------------------------------*/
		if( player1->getHPf() >= player2->getHPf() )
			DrawFormatStringToHandle( 240, 175, 0xff0000, FONT_HANDLE2, "%3d %%", (int)( player1->getHPf() * 100 ) );
		else
			DrawFormatStringToHandle( 240, 175, 0xffffff, FONT_HANDLE2, "%3d %%", (int)( player1->getHPf() * 100 ) );
		if( player2->getHPf() >= player1->getHPf() )
			DrawFormatStringToHandle( 460, 175, 0xff0000, FONT_HANDLE2, "%d %%", (int)( player2->getHPf() * 100 ) );
		else
			DrawFormatStringToHandle( 460, 175, 0xffffff, FONT_HANDLE2, "%d %%", (int)( player2->getHPf() * 100 ) );

	}
	else if( state == FIGHT_END )
	{
		if( p1Point >= NANBON && p2Point >= NANBON )
		{
			DrawStringToHandle( 225, 250, "DRAW", 0x80ff80, FONT_HANDLE4 );
		}
		else if( p1Point >= NANBON )
		{
			DrawStringToHandle( 120, 250, "RED WIN", 0xff8080, FONT_HANDLE4 );

			/*------------------------------
			 * REDWIN̉
			------------------------------*/
			if( time == 0 )
				PlaySoundMem( SE[ SE_REDWIN ] , DX_PLAYTYPE_BACK );
		}
		else if( p2Point >= NANBON )
		{
			DrawStringToHandle( 80, 250, "BLUE WIN", 0x8080ff, FONT_HANDLE4 );

			/*------------------------------
			 * BLUEWIN̉
			------------------------------*/
			if( time == 0 )
				PlaySoundMem( SE[ SE_BLUEWIN ] , DX_PLAYTYPE_BACK );
		}
	}
}

/*------------------------------
 * ֐ FIGHT::loadChara, unloadChara
 * Q[JnɃL[h, A[hB
------------------------------*/
void FIGHT::loadChara( int p1, int p2 )
{
	unloadChara();

	// player1 = new CHARA_NGUYEN();
	// player2 = new CHARA_YUKO();


	// _IĂ
	if( p1 == CHARA_NAME_RANDOM )
	{
		p1 = getIntRand( 0, 11 );
		if( p1 >= CHARA_NAME_RANDOM )
			p1++;
	}
	if( p2 == CHARA_NAME_RANDOM )
	{
		p2 = getIntRand( 0, 11 );
		if( p2 >= CHARA_NAME_RANDOM )
			p2++;
	}

	switch( p1 )
	{
	case CHARA_NAME_TAKASHI:
		player1 = new CHARA_TAKASHI();
		break;
	case CHARA_NAME_KENTA:
		player1 = new CHARA_KENTA();
		break;
	case CHARA_NAME_JOHNSON:
		player1 = new CHARA_JOHNSON();
		break;
	case CHARA_NAME_GARCIA:
		player1 = new CHARA_GARCIA();
		break;
	case CHARA_NAME_WANG:
		player1 = new CHARA_WANG();
		break;
	case CHARA_NAME_LYNDEM:
		player1 = new CHARA_LYNDEM();
		break;
	case CHARA_NAME_NGUYEN:
		player1 = new CHARA_NGUYEN();
		break;
	case CHARA_NAME_YUKO:
		player1 = new CHARA_YUKO();
		break;
	case CHARA_NAME_HECKLER:
		player1 = new CHARA_HECKLER();
		break;
	case CHARA_NAME_ICHI:
		player1 = new CHARA_ICHI();
		break;
	case CHARA_NAME_COX:
		player1 = new CHARA_COX();
		break;
	case CHARA_NAME_MICHAEL:
		player1 = new CHARA_MICHAEL();
		break;
	default:
		break;
	}

	switch( p2 )
	{
	case CHARA_NAME_TAKASHI:
		player2 = new CHARA_TAKASHI();
		break;
	case CHARA_NAME_KENTA:
		player2 = new CHARA_KENTA();
		break;
	case CHARA_NAME_JOHNSON:
		player2 = new CHARA_JOHNSON();
		break;
	case CHARA_NAME_GARCIA:
		player2 = new CHARA_GARCIA();
		break;
	case CHARA_NAME_WANG:
		player2 = new CHARA_WANG();
		break;
	case CHARA_NAME_LYNDEM:
		player2 = new CHARA_LYNDEM();
		break;
	case CHARA_NAME_NGUYEN:
		player2 = new CHARA_NGUYEN();
		break;
	case CHARA_NAME_YUKO:
		player2 = new CHARA_YUKO();
		break;
	case CHARA_NAME_HECKLER:
		player2 = new CHARA_HECKLER();
		break;
	case CHARA_NAME_ICHI:
		player2 = new CHARA_ICHI();
		break;
	case CHARA_NAME_COX:
		player2 = new CHARA_COX();
		break;
	case CHARA_NAME_MICHAEL:
		player2 = new CHARA_MICHAEL();
		break;
	default:
		break;
	}

}
void FIGHT::unloadChara(void)
{
	delete player1;
	delete player2;

	player1 = player2 = 0;
}

/*------------------------------
 * ֐ FIGHT::loadStage, unloadStage
 * Q[JnɃXe[W[h, A[hB
------------------------------*/
void FIGHT::loadStage( int stg )
{
	if( !stage )
		stage = new STAGE();

	// _IĂƂ
	if( stg == STAGE_RANDOM )
		stg = getIntRand( 0, 3 );

	stage->setStage( stg );
}
void FIGHT::unloadStage(void)
{
	delete stage;

	stage = 0;
}

/*------------------------------
 * ֐ FIGHT::master
 * ̃}X^[s
------------------------------*/
void FIGHT::master(void)
{
	player1->update(); player2->update();			// vC[𓮂

	// sȓƂ͌ɖ߂
	for(int i=0;i<10;i++)
	{
		if( player1->getPosition() < stage->getLeftCorner() )
		{
			player1->moveBack();
			continue;
		}
		if( stage->getRightCorner() < player2->getPosition() )
		{
			player2->moveBack();
			continue;
		}
		if( player2->getPosition() <= player1->getPosition() )
		{
			player1->moveBack();
			player2->moveBack();
			continue;
		}
		break;
	}

	int p1Attack = player1->getAttack();
	int p2Attack = player2->getAttack();

	if( p1Attack != -1 )
		player2->checkAttack( p1Attack, player1->getPosition() + 1, player1->getPosition() + WAZA_STATUS[ p1Attack ][ WAZA_REACH ] );
	if( p2Attack != -1 )
		player1->checkAttack( p2Attack, player2->getPosition() - WAZA_STATUS[ p2Attack ][ WAZA_REACH ], player2->getPosition() - 1 );

}
/*------------------------------
 * ֐ FIGHT::check
 * ̃}X^[s
------------------------------*/
void FIGHT::check(void)
{
	/*------------------------------
	 * KO
	------------------------------*/
	if( player1->getHP() == 0 && player2->getHP() == 0 )
	{
		state = FIGHT_DOUBLEKO;					// DOUBLE KO
		time = 0;

		p1Point++; p2Point++;
	}
	else if( player1->getHP() == 0 )
	{
		state = FIGHT_KO;						// 1P KO
		time = 0;

		p2Point++;
	}
	else if( player2->getHP() == 0 )
	{
		state = FIGHT_KO;						// 2P KO
		time = 0;

		p1Point++;
	}
	/*------------------------------
	 * ^CAbv
	------------------------------*/
	else if( remain <= 0 )
	{
		if( player1->getHPf() > player2->getHPf() )		// 1p菟
		{
			p1Point++;

			player1->setNoDamage( TRUE );		// _[WȂ悤ɂ
			player2->setNoDamage( TRUE );
		}
		else if( player2->getHPf() > player1->getHPf() ) // 2p菟
		{
			p2Point++;
			player1->setNoDamage( TRUE );		// _[WȂ悤ɂ
			player2->setNoDamage( TRUE );
		}
		else									// 
		{
			p1Point++; p2Point++;
			player1->setNoDamage( TRUE );		// _[WȂ悤ɂ
			player2->setNoDamage( TRUE );
		}

		state = FIGHT_TIMEUP;
		time = 0;
	}
}
/*------------------------------
 * ֐ FIGHT::goNextRound
 * ̃Eh
------------------------------*/
void FIGHT::goNextRound(void)
{
	/*------------------------------
	 * 
	------------------------------*/
	if( p1Point >= NANBON || p2Point >= NANBON )
	{
		state = FIGHT_END;
		time = 0;

		player1->setNoDamage( TRUE );			// _[WȂ悤ɂ
		player2->setNoDamage( TRUE );
		return;
	}	

	/*------------------------------
	 * ̃Eh
	------------------------------*/
	player1->init(1); player2->init(-1);

	state = FIGHT_STARTING;
	time = -1;
	round++;
	remain = FIGHTING_TIME;
}