/*------------------------------
 *
 * iQ[
 *
 * player wb_[
 * vC[̊ǗS
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define PLAYER_H								// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[

#include "main.h"								// main wb_[
#include "player.h"								// player wb_[
#include "stage.h"								// stage wb_[

#include "key.h"								// key wb_[

/*------------------------------
 * ֐ loadCharaGraph, loadCharaGraph
 * L̉摜[h, A[h
------------------------------*/
void loadCharaGraph(void)
{
	CharaGraph = new int[ 100 ];

	for(int i=0;i<100;i++)
		CharaGraph[i] = -1;

	CharaGraph[ CHARAGRAPH_TACHI0			] = LoadGraph( "image/chara/common/Tachi0.png" );
	CharaGraph[ CHARAGRAPH_TACHI1			] = LoadGraph( "image/chara/common/Tachi1.png" );
	CharaGraph[ CHARAGRAPH_MAESTEP			] = LoadGraph( "image/chara/common/MaeStep.png" );
	CharaGraph[ CHARAGRAPH_BACKSTEP			] = LoadGraph( "image/chara/common/BackStep.png" );
	CharaGraph[ CHARAGRAPH_TAORE0			] = LoadGraph( "image/chara/common/Taore0.png" );
	CharaGraph[ CHARAGRAPH_TAORE1			] = LoadGraph( "image/chara/common/Taore1.png" );
	CharaGraph[ CHARAGRAPH_TAORE2			] = LoadGraph( "image/chara/common/Taore2.png" );
	CharaGraph[ CHARAGRAPH_HISSATSUTAORE0	] = LoadGraph( "image/chara/common/HissatsuTaore0.png" );
	CharaGraph[ CHARAGRAPH_HISSATSUTAORE1	] = LoadGraph( "image/chara/common/HissatsuTaore1.png" );
	CharaGraph[ CHARAGRAPH_HISSATSUTAORE2	] = LoadGraph( "image/chara/common/HissatsuTaore2.png" );
	CharaGraph[ CHARAGRAPH_FIRE				] = LoadGraph( "image/chara/common/Fire.png" );
	CharaGraph[ CHARAGRAPH_COMMON_KAMAE		] = LoadGraph( "image/chara/common/Kamae.png" );
	CharaGraph[ CHARAGRAPH_TAKASHI_JAKU0	] = LoadGraph( "image/chara/takashi/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_TAKASHI_JAKU1	] = LoadGraph( "image/chara/takashi/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_TAKASHI_KYOU0	] = LoadGraph( "image/chara/takashi/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_TAKASHI_KYOU1	] = LoadGraph( "image/chara/takashi/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_TAKASHI_SPCL0	] = LoadGraph( "image/chara/takashi/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_TAKASHI_SPCL1	] = LoadGraph( "image/chara/takashi/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_KENTA_SPCL0		] = LoadGraph( "image/chara/kenta/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_KENTA_SPCL1		] = LoadGraph( "image/chara/kenta/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_KENTA_SPCL2		] = LoadGraph( "image/chara/kenta/Hissatsu2.png" );
	CharaGraph[ CHARAGRAPH_JOHNSON_KYOU0	] = LoadGraph( "image/chara/johnson/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_JOHNSON_KYOU1	] = LoadGraph( "image/chara/johnson/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_JOHNSON_SPCL0	] = LoadGraph( "image/chara/johnson/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_JOHNSON_SPCL1	] = LoadGraph( "image/chara/johnson/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_KAMAE		] = LoadGraph( "image/chara/garcia/Kamae.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_JAKU0		] = LoadGraph( "image/chara/garcia/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_JAKU1		] = LoadGraph( "image/chara/garcia/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_KYOU0		] = LoadGraph( "image/chara/garcia/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_KYOU1		] = LoadGraph( "image/chara/garcia/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_SPCL0		] = LoadGraph( "image/chara/garcia/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_GARCIA_SPCL1		] = LoadGraph( "image/chara/garcia/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_WANG_KAMAE		] = LoadGraph( "image/chara/wang/Kamae.png" );
	CharaGraph[ CHARAGRAPH_WANG_YASUMI		] = LoadGraph( "image/chara/wang/Yasumi.png" );
	CharaGraph[ CHARAGRAPH_WANG_JAKU0		] = LoadGraph( "image/chara/wang/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_WANG_KYOU0		] = LoadGraph( "image/chara/wang/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_WANG_SPCL0		] = LoadGraph( "image/chara/wang/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_KAMAE		] = LoadGraph( "image/chara/lyndem/Kamae.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_JAKU0		] = LoadGraph( "image/chara/lyndem/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_JAKU1		] = LoadGraph( "image/chara/lyndem/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_KYOU0		] = LoadGraph( "image/chara/lyndem/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_KYOU1		] = LoadGraph( "image/chara/lyndem/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_SPCL0		] = LoadGraph( "image/chara/lyndem/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_LYNDEM_SPCL1		] = LoadGraph( "image/chara/lyndem/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_JAKU0		] = LoadGraph( "image/chara/nguyen/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_JAKU1		] = LoadGraph( "image/chara/nguyen/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_KYOU0		] = LoadGraph( "image/chara/nguyen/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_KYOU1		] = LoadGraph( "image/chara/nguyen/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_SPCL0		] = LoadGraph( "image/chara/nguyen/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_SPCL1		] = LoadGraph( "image/chara/nguyen/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_NGUYEN_SPCL2		] = LoadGraph( "image/chara/nguyen/Hissatsu2.png" );
	CharaGraph[ CHARAGRAPH_YUKO_KAMAE		] = LoadGraph( "image/chara/yuko/Kamae.png" );
	CharaGraph[ CHARAGRAPH_YUKO_JAKU0		] = LoadGraph( "image/chara/yuko/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_YUKO_JAKU1		] = LoadGraph( "image/chara/yuko/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_YUKO_KYOU0		] = LoadGraph( "image/chara/yuko/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_YUKO_KYOU1		] = LoadGraph( "image/chara/yuko/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_KAMAE	] = LoadGraph( "image/chara/heckler/Kamae.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_JAKU0	] = LoadGraph( "image/chara/heckler/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_JAKU1	] = LoadGraph( "image/chara/heckler/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_KYOU0	] = LoadGraph( "image/chara/heckler/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_KYOU1	] = LoadGraph( "image/chara/heckler/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_SPCL0	] = LoadGraph( "image/chara/heckler/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_HECKLER_SPCL1	] = LoadGraph( "image/chara/heckler/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_ICHI_KYOU0		] = LoadGraph( "image/chara/ichi/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_ICHI_KYOU1		] = LoadGraph( "image/chara/ichi/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_ICHI_SPCL0		] = LoadGraph( "image/chara/ichi/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_ICHI_SPCL1		] = LoadGraph( "image/chara/ichi/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_COX_KAMAE		] = LoadGraph( "image/chara/cox/Kamae.png" );
	CharaGraph[ CHARAGRAPH_COX_KYOU0		] = LoadGraph( "image/chara/cox/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_COX_KYOU1		] = LoadGraph( "image/chara/cox/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_COX_SPCL0		] = LoadGraph( "image/chara/cox/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_COX_SPCL1		] = LoadGraph( "image/chara/cox/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_COX_SPCL2		] = LoadGraph( "image/chara/cox/Hissatsu2.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_KAMAE	] = LoadGraph( "image/chara/michael/Kamae.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_JAKU0	] = LoadGraph( "image/chara/michael/Jaku0.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_JAKU1	] = LoadGraph( "image/chara/michael/Jaku1.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_KYOU0	] = LoadGraph( "image/chara/michael/Kyou0.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_KYOU1	] = LoadGraph( "image/chara/michael/Kyou1.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_SPCL0	] = LoadGraph( "image/chara/michael/Hissatsu0.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_SPCL1	] = LoadGraph( "image/chara/michael/Hissatsu1.png" );
	CharaGraph[ CHARAGRAPH_MICHAEL_SPCL2	] = LoadGraph( "image/chara/michael/Hissatsu2.png" );


}
void unloadCharaGraph(void)
{
	for(int i=0;i<100;i++)
	{
		if( CharaGraph[ i ] != -1 )
			DeleteGraph( CharaGraph[ i ] );
	}

	delete [] CharaGraph;
}

/*------------------------------
 * ֐ PLAYER::init
 * vC[̏s
------------------------------*/
void PLAYER::init( int dir )
{
	direction = dir;

	HP = getOwnInitHP();
	HPsub = getOwnInitHP();
	
	if( direction == 1 )
		position = 0;
	else
		position = 3;

	act = ACT_TACHI;
	time = -1;
	precede = NO_PRECEDE;
	special = 0;
	move = 0;

	yarare_flame = 0;
	attack = -1;
	state = STATE_NORMAL;

	cant_move = TRUE;
	no_damage = TRUE;
}
/*------------------------------
 * ֐ PLAYER::update
 * vC[̍XVs
------------------------------*/
void PLAYER::update(void)
{
	// ʏ
	time++;										// Ԍo
	move = 0;									// O̓̏
	decreaseHPsub();

	if( cant_move ) return;

	switch( act )
	{
	case ACT_MAESTEP:
	case ACT_BACKSTEP:
		if( 6 <= time )							// KȎԂoĂ, ɖ߂
		{
			act = ACT_TACHI;
			time = 0;
		}
	case ACT_TACHI:
		/*------------------------------
		 * ړ̏
		------------------------------*/
		if( direction == 1 )
		{
			if( getButtonRight() == 1 )
				moveRight();
			else if( getButtonLeft() == 1 )
				moveLeft();
			else if( precede == PRECEDE_MIGI )
				moveRight();
			else if( precede == PRECEDE_HIDARI )
				moveLeft();
		}
		else
		{
			if( getButtonLeft() == 1 )
				moveLeft();
			else if( getButtonRight() == 1 )
				moveRight();
			else if( precede == PRECEDE_MIGI )
				moveRight();
			else if( precede == PRECEDE_HIDARI )
				moveLeft();
		}
		/*------------------------------
		 * Ȕ
		------------------------------*/
		if( getButtonKyou() == 1 )
			attackKyou();
		else if( getButtonJaku() == 1 )
			attackJaku();
		else if( precede == PRECEDE_SPCL )
			attackSpecial();
		else if( precede == PRECEDE_KYOU )
			attackKyou();
		else if( precede == PRECEDE_JAKU )
			attackJaku();

		if( getButtonJaku() == 1 && getButtonKyou() == 1 )
			attackSpecial();

		precede = NO_PRECEDE;
		break;
	case ACT_JAKU_KOUGEKI:
		whileJaku();
		break;
	case ACT_KYOU_KOUGEKI:
		whileKyou();
		break;
	case ACT_SPCL_KOUGEKI:
		whileSpecial();
		break;
	case ACT_YARARE_NORMAL:
	case ACT_YARARE_SPECIAL0:
	case ACT_YARARE_SPECIAL1:
	case ACT_YARARE_SPECIAL2:
		/*------------------------------
		 * s͂̎t
		------------------------------*/
		if( yarare_flame - SENKOU_NYURYOKU_FLAME <= time )
			setPrecede();
		/*------------------------------
		 * ̏I
		------------------------------*/
		if( yarare_flame <= time )
		{
			if( HP <= 0 )						// HP[ȂÂ܂ܓ|Ă
			{
				act = ACT_KO;
				time = 0;
				state = STATE_NORMAL;			// ʏԂɖ߂
			}
			else
			{
				act = ACT_TACHI;
				time = 0;
				state = STATE_NORMAL;			// ʏԂɖ߂

				actionPrecede();				// s͂̎s
			}
		}
		break;
	case ACT_KO:
	default:
		break;
	}


}
/*------------------------------
 * ֐ PLAYER::draw
 * vC[`ʂ
------------------------------*/
void PLAYER::output(void)
{
}

/*------------------------------
 * ֐ PLAYER::moveLeft
 * vC[ɓ
------------------------------*/
void PLAYER::moveLeft(void)
{
	if( direction == 1 )
		act = ACT_BACKSTEP;
	else
		act = ACT_MAESTEP;

	time = 0;

	position--;
	move--;										// L

	/*
	if( position < Lside )
	{
		position = Lside;
		move++;									// C
	}
	*/

	PlaySoundMem( SE[ SE_STEP ] , DX_PLAYTYPE_BACK );
												// o
}
/*------------------------------
 * ֐ PLAYER::moveRight
 * vC[Eɓ
------------------------------*/
void PLAYER::moveRight(void)
{
	if( direction == 1 )
		act = ACT_MAESTEP;
	else
		act = ACT_BACKSTEP;

	time = 0;

	position++;
	move++;										// L

	/*
	if( Rside < position )
	{
		position = Rside;
		move--;								// C
	}
	*/

	PlaySoundMem( SE[ SE_STEP ] , DX_PLAYTYPE_BACK );
												// o
}
/*------------------------------
 * ֐ PLAYER::moveBack
 * vC[̈ʒuɖ߂
------------------------------*/
void PLAYER::moveBack(void)
{
	if( move > 0 )
	{
		position--;
		move--;
	}
	else if( move < 0 )
	{
		position++;
		move++;	
	}
}

/*------------------------------
 * ֐ PLAYER::setPrecede
 * s͂̎t
------------------------------*/
void PLAYER::setPrecede(void)
{
	if( direction == 1 )						// Oi̕Dʂł邽
	{
		if( getButtonLeft() == 1 )
			precede = PRECEDE_HIDARI;
		if( getButtonRight() == 1 )
			precede = PRECEDE_MIGI;
	}
	else
	{
		if( getButtonRight() == 1 )
			precede = PRECEDE_MIGI;
		if( getButtonLeft() == 1 )
			precede = PRECEDE_HIDARI;	
	}

	if( getButtonJaku() == 1 )
		precede = PRECEDE_JAKU;
	if( getButtonKyou() == 1 )
		precede = PRECEDE_KYOU;

	if( special == 1 && getButtonJaku() == 1 && getButtonKyou() == 1 )
		precede = PRECEDE_SPCL;
}
/*------------------------------
 * ֐ PLAYER::actionPrecede
 * s͂̎s
------------------------------*/
void PLAYER::actionPrecede(void)
{
	switch( precede )
	{
	case PRECEDE_HIDARI:
		moveLeft(  );
		break;
	case PRECEDE_MIGI:
		moveRight();
		break;
	case PRECEDE_JAKU:
		attackJaku();
		break;
	case PRECEDE_KYOU:
		attackKyou();
		break;
	case PRECEDE_SPCL:
		attackSpecial();
		break;
	default:
		break;
	}

	precede = NO_PRECEDE;
}

/*------------------------------
 * ֐ PLAYER::getAttack
 * U肪邩ۂ̊mF
------------------------------*/
int PLAYER::getAttack(void)
{
	int t = attack;
	attack = -1;
	return t;
}
/*------------------------------
 * ֐ PLAYER::checkAttack
 * UۂmFB
------------------------------*/
void PLAYER::checkAttack( int waza, int x0, int x1 )
{
	if( state == STATE_MUTEKI ) return;			// GԂȂ牽ȂB
	if( x0 > position || position > x1 ) return; // ĂȂΉȂB

	if( !no_damage )							// GԂȂ΍U󂯂Ȃ
	{
		// Ԃɂă_[W͕ςB
		switch( state )
		{
		case STATE_NORMAL:						// ʏԂȂ
			HP -= WAZA_STATUS[ waza ][ WAZA_DAMAGE ]; // _[Ŵ܂
			break;
		case STATE_ATTACK:						// UȂ
			HP -= WAZA_STATUS[ waza ][ WAZA_DAMAGE ] * 4 / 3; // _[W4/3{
			break;
		case STATE_YARARE:						// ԂȂ
			HP -= WAZA_STATUS[ waza ][ WAZA_DAMAGE ] / 2; // _[W0.5{
			break;
		}
	}

	yarare_flame = WAZA_STATUS[ waza ][ WAZA_KOUCHOKU_FLAME ]; // d
	act = WAZA_STATUS[ waza ][ WAZA_NANIYARARE ]; // ԂςB
	state = STATE_YARARE;						// Ԃ
	time = 0;
	precede = NO_PRECEDE;						// s͂

	if( 0 < HP && HP <= getOwnInitHP() / 2 && special == 0 ) // HP2ȉɂȂΕKEZĂ
	{
		special = 1;
		PlaySoundMem( SE[ SE_FIRE ] , DX_PLAYTYPE_BACK );
												// o
	}
	if( HP <= 0 )								// HP[I
		HP = 0;									// Ô

	PlaySoundMem( SE[ WAZA_STATUS[ waza ][ WAZA_HITSE ] ] , DX_PLAYTYPE_BACK );
												// o

}

/*------------------------------
 * ֐ PLAYER::getButtonLeft
 * {^̓͂̊mF
------------------------------*/
int PLAYER::getButtonLeft(void)
{
	if( direction == 1 )
		return getKeyState( KEY_INPUT_A );
	else
		return getKeyState( KEY_INPUT_LEFT );
}
/*------------------------------
 * ֐ PLAYER::getButtonRight
 * E{^̓͂̊mF
------------------------------*/
int PLAYER::getButtonRight(void)
{
	if( direction == 1 )
		return getKeyState( KEY_INPUT_D );
	else
		return getKeyState( KEY_INPUT_RIGHT );
}
/*------------------------------
 * ֐ PLAYER::getButtonJaku
 * {^̓͂̊mF
------------------------------*/
int PLAYER::getButtonJaku(void)
{
	if( direction == 1 )
		return getKeyState( KEY_INPUT_W );
	else
		return getKeyState( KEY_INPUT_UP );
}
/*------------------------------
 * ֐ PLAYER::getButtonKyou
 * {^̓͂̊mF
------------------------------*/
int PLAYER::getButtonKyou(void)
{
	if( direction == 1 )
		return getKeyState( KEY_INPUT_S );
	else
		return getKeyState( KEY_INPUT_DOWN );
}

/*------------------------------
 * ֐ PLAYER::getPosition
 * |WVԂ
------------------------------*/
int PLAYER::getPosition(void)
{
	return position;
}

/*------------------------------
 * ֐ PLAYER::decreaseHPsub
 * ԃQ[W炷BQ[ł͈Ӗ͖
------------------------------*/
void PLAYER::decreaseHPsub(void)
{
	if( HPsub > HP ) HPsub -= getOwnInitHP() / 180;
	
	if( HPsub < HP ) HPsub = HP; // C
}

/*------------------------------
 * ֐ PLAYER::getHP
 * ̗͂Ԃ
------------------------------*/
int PLAYER::getHP(void)
{
	return HP;
}
/*------------------------------
 * ֐ PLAYER::getHPf
 * ̗͂Ԃ(double^)
------------------------------*/
double PLAYER::getHPf(void)
{
	return (double)HP / getOwnInitHP();
}
/*------------------------------
 * ֐ PLAYER::getHPsubf
 * FQ[WԂ(double^)
------------------------------*/
double PLAYER::getHPsubf(void)
{
	return (double)HPsub / getOwnInitHP();
}

/*------------------------------
 * ֐ PLAYER::setCantMove
 * 悤ɂorȂ
------------------------------*/
void PLAYER::setCantMove( int x )
{
	cant_move = x;
}
/*------------------------------
 * ֐ PLAYER::setNoDamage
 * 炤orHȂ悤ɂ
------------------------------*/
void PLAYER::setNoDamage( int x )
{
	no_damage = x;
}

void PLAYER::attackJaku(void) {}
void PLAYER::attackKyou(void) {}
void PLAYER::attackSpecial(void) {}
void PLAYER::whileJaku(void) {}
void PLAYER::whileKyou(void) {}
void PLAYER::whileSpecial(void) {}
int PLAYER::getOwnInitHP(void) { return -1; }
char* PLAYER::getOwnName(void) { return 0; }