/*------------------------------
 *
 * iQ[
 *
 * stage wb_[
 * Xe[W̊ǗS
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define STAGE_H								// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[
#include "stage.h"								// stage wb_[

/*------------------------------
 * ֐ loadStageGraph, unloadStageGraph
 * L̉摜[h, A[h
------------------------------*/
void loadStageGraph(void)
{
	StageGraph = new int[ 4 ];

	for(int i=0;i<4;i++)
		StageGraph[i] = -1;

	StageGraph[ STAGE_HITOGOMI			] = LoadGraph( "image/background/hitogomi.png" );
	StageGraph[ STAGE_STREET			] = LoadGraph( "image/background/street.png" );
	StageGraph[ STAGE_DEFAULT			] = LoadGraph( "image/background/normal.png" );
	StageGraph[ STAGE_FOREST			] = LoadGraph( "image/background/forest.png" );


}
void unloadStageGraph(void)
{
	for(int i=0;i<4;i++)
	{
		if( StageGraph[ i ] != -1 )
			DeleteGraph( StageGraph[ i ] );
	}

	delete [] StageGraph;
}

/*------------------------------
 * ֐ setStage
 * Xe[WZbg
------------------------------*/
void STAGE::setStage( int x )
{
	stage = x;
}
/*------------------------------
 * ֐ output
 * Xe[W`ʂ
------------------------------*/
void STAGE::output(void)
{
	switch( stage )
	{
	case STAGE_HITOGOMI:
	case STAGE_STREET:
	case STAGE_DEFAULT:
	case STAGE_FOREST:
		DrawGraph( 0, 75, StageGraph[ stage ], TRUE );
		break;
	default:
		break;
	}
}

/*------------------------------
 * ֐ getLeftCorner
 * [̍WԂ
------------------------------*/
int STAGE::getLeftCorner(void)
{
	return STAGE_WIDE[ stage ][ 0 ];
}
/*------------------------------
 * ֐ getRightCorner
 * E[̍WԂ
------------------------------*/
int STAGE::getRightCorner(void)
{
	return STAGE_WIDE[ stage ][ 1 ];
}